var fs=require('fs')
var server=require('http').createServer((req,res)=>{
	if(req.url=='/') req.url='/index.html'
	if(req.url.includes('html')) res.writeHead(200,{'Content-Type': 'text/html'})
	try {
		res.end(fs.readFileSync('frontend'+req.url));
	} catch {
		res.end('file not found');
	}
})
server.listen(80)
wslib=require('ws')
var ws=new wslib.Server({server})
var roll=require('./roll.js')
var bot=require('./rolitbot.js')
var kickInterval=null
var games={}
function startInterval() {
	if(kickInterval) return
		console.log('starting interval')
		kickInterval=setInterval(function () {
			ws.clients.forEach(function(ws) {
				if(!ws.isAlive) {
					console.log('terminated connection')
					return ws.terminate();
				}
				ws.isAlive=false
				ws.ping(function () {})
			})
			if(ws.clients.size==0) {
				clearInterval(kickInterval)
				kickInterval=null
			}
			console.log('sending pings')
		},15*1000)
}
function checkMogelijk(grid,speler) {
	var grid=JSON.parse(JSON.stringify(grid))
	var mogelijk=false
	grid.forEach(function (row,x) {
		row.forEach(function (cell,y) {
			if(grid[x][y]>-1) return
				if(roll(grid,speler,x,y)) {
					mogelijk=true
				}
		})
	})
	return mogelijk
}
function checkAround(grid,x,y) {
	if([[x-1,y-1],[x-1,y],[x-1,y+1],[x,y-1],[x,y+1],[x+1,y+1],[x+1,y],[x+1,y-1]].map(function (check) {return (grid[check[0]] && grid[check[0]][check[1]]>-1)}).indexOf(true)>-1) return true
	else return false
}
ws.on('connection', function (connection,request) {
	if(ws.clients.size==1) startInterval()
	var gameId=request.url.split('/')[1]
	if(!games[gameId]) games[gameId]=createGame(gameId)
	game=games[gameId]
	game.clients.push(connection)
	if(!game.started) {
		game.aantalSpelers++
		connection.playerId=game.aantalSpelers
		if(game.aantalSpelers==3) game.started=true
	} else {
		connection.playerId=999
		connection.send(JSON.stringify(getSpelerInfo(connection.playerId)))
	}
	connection.gameId=gameId
	connection.isAlive=true
	connection.on('pong',function () {this.isAlive=true; console.log('pong received!')})
	connection.on('message',function (message) {
		game=games[gameId]
		game.deleteTimeout=removeTimeout(gameId)
		data={}
		try {
			data=JSON.parse(message)
		} catch(e) {
			return
		}
		if(receiveFromSpeler(connection,data.actie,data.data)) games[gameId]=undefined
		else games[gameId]=game
	})
	sendToPlayers()
})
function removeGame(gameId) {
	game=games[gameId]
	endWithMessage('2 uur verstreken, game wordt gewist.')
	games[gameId]=undefined
}
function removeTimeout(gameId,first) {
	if(!first) clearTimeout(games[gameId].deleteTimeout)
		return setTimeout(function() {games[gameId]=undefined},2*60*60*1000)
		//todo
		//return setTimeout(function() {removeGame(gameId)},30000)
}
function newGrid() {
	size=8
	grid=JSON.parse(JSON.stringify(new Array(size).fill(new Array(size).fill(-1))))
	if(size==4) {
		grid[1][1]=0
		grid[1][2]=1
		grid[2][1]=2
		grid[2][2]=3
	} else {
		grid[3][3]=0
		grid[3][4]=1
		grid[4][3]=2
		grid[4][4]=3
	}
	return grid
}
function createGame(gameId) {
	return {
		difficulty:50,
		gameId:gameId,
		bots:[],
		started:false,
		grid:newGrid(),
		beurt:0,
		aantalSpelers:-1,
		clients:[],
		deleteTimeout:removeTimeout(gameId,true)
	}
}
function getSpelerInfo(spelerId) {
	if(game.started) {
		return {
			started:game.started,
			grid:game.grid,
			beurt:game.beurt,
			spelerId:spelerId,
			spelerAantal: game.aantalSpelers
		}
	}else {
		return {
			started: game.started,
			spelerId:spelerId,
			spelerAantal:game.aantalSpelers+1
		}
	}
}
function sendToPlayers() {
	game.clients.forEach(function (client) {
		client.send(JSON.stringify(getSpelerInfo(client.playerId)))
	})
	console.log(game.bots)
	if(game.bots.indexOf(game.beurt)>-1) {
		bot(game.difficulty,JSON.parse(JSON.stringify(getSpelerInfo(game.beurt))),function (actie,data) {
			receiveFromSpeler({playerId:game.beurt},actie,data)
		})
	}
}
function endWithMessage(message) {
	game.clients.forEach(function (client) {
		client.close(4321,message)
	})
	games[game.gameId]=undefined
}
function receiveFromSpeler(connection,actie,arguments) {
	spelerId=connection.playerId
	if(actie=="start" && !game.started) {
		if(game.aantalSpelers==0) {
			game.aantalSpelers++
			game.bots.push(game.aantalSpelers)
		}
		game.beurt=0
		game.started=true
		sendToPlayers()
		return
	} else if(actie=="stop" && game.started) {
		if(spelerId>game.aantalSpelers) connection.close(4321,'geen speler.')
		else {
			sendToPlayers("game gestopt door speler "+spelerId+".")
			return true
		}
	} else if(spelerId==game.beurt) {
		if(actie=="difficulty") {
			game.difficulty=parseInt(arguments)
		} else if(actie=="roll") {
			x=parseInt(arguments.x)
			y=parseInt(arguments.y)
			console.log('rolling',x,y)
			if(game.grid[x] && game.grid[x][y]>-1) {
				console.log('al geplaatst')
				sendToPlayers()
				return
			}
			newgrid=roll(JSON.parse(JSON.stringify(game.grid)),spelerId,x,y).grid
			console.log('newgrid:',newgrid)
			if(newgrid) {
				game.grid=newgrid
				game.beurt++
				if(game.beurt>game.aantalSpelers) game.beurt=0
			} else {
				mogelijk=checkMogelijk(game.grid,spelerId)
				console.log('mogelijk:',mogelijk)
				if(!mogelijk) {
					if(checkAround(game.grid,x,y)) {
						console.log('checkAround=true')
						game.grid[x][y]=spelerId
						game.beurt++
						if(game.beurt>game.aantalSpelers) game.beurt=0
					} else {
						console.log('checkAround=false')
					}
				}
			}
		}
		sendToPlayers();
		if(game.grid.filter(function (row,rowId) {
			return row.filter(function (cell) {return cell>-1}).length==8
		}).length==8) {
			endWithMessage('spel is geeindigd');
			return true
		}
	} else {
		console.log('beurt:',game.beurt,'speler:',spelerId)
		console.log("niet aan de beurt")
	}
}
console.log('started!')
